libfuse: fuse_config Struct Reference

libfuse

Data Fields
fuse_config Struct Reference

`#include <fuse.h>`

## Data Fields
int | set_gid
int | set_uid
int | set_mode
double | entry_timeout
double | negative_timeout
double | attr_timeout
int | intr
int | intr_signal
int | remember
int | hard_remove
int | use_ino
int | readdir_ino
int | direct_io
int | kernel_cache
int | auto_cache
int | ac_attr_timeout_set
int | nullpath_ok
int | show_help

## Detailed Description

Configuration of the high-level API

This structure is initialized from the arguments passed to fuse_new(), and then passed to the file system's init() handler which should ensure that the configuration is compatible with the file system implementation.

Definition at line 93 of file fuse.h.

## Field Documentation

## ◆ ac_attr_timeout_set

int fuse_config::ac_attr_timeout_set

The timeout in seconds for which file attributes are cached for the purpose of checking if auto_cache should flush the file data on open.

Definition at line 252 of file fuse.h.

## ◆ attr_timeout

double fuse_config::attr_timeout

The timeout in seconds for which file/directory attributes (as returned by e.g. the `getattr` handler) are cached.

Definition at line 135 of file fuse.h.

## ◆ auto_cache

int fuse_config::auto_cache

This option is an alternative to `kernel_cache`. Instead of unconditionally keeping cached data, the cached data is invalidated on open(2) if if the modification time or the size of the file has changed since it was last opened.

Definition at line 245 of file fuse.h.

## ◆ direct_io

int fuse_config::direct_io

This option disables the use of page cache (file content cache) in the kernel for this filesystem. This has several affects:

1. Each read(2) or write(2) system call will initiate one or more read or write operations, data will not be cached in the kernel.
2. The return value of the read() and write() system calls will correspond to the return values of the read and write operations. This is useful for example if the file size is not known in advance (before reading it).

Internally, enabling this option causes fuse to set the `direct_io` field of `struct fuse_file_info` - overwriting any value that was put there by the file system.

Definition at line 218 of file fuse.h.

## ◆ entry_timeout

double fuse_config::entry_timeout

The timeout in seconds for which name lookups will be cached.

Definition at line 119 of file fuse.h.

## ◆ hard_remove

int fuse_config::hard_remove

The default behavior is that if an open file is deleted, the file is renamed to a hidden file (.fuse_hiddenXXX), and only removed when the file is finally released. This relieves the filesystem implementation of having to deal with this problem. This option disables the hiding behavior, and files are removed immediately in an unlink operation (or in a rename operation which overwrites an existing file).

It is recommended that you not use the hard_remove option. When hard_remove is set, the following libc functions fail on unlinked files (returning errno of ENOENT): read(2), write(2), fsync(2), close(2), f*xattr(2), ftruncate(2), fstat(2), fchmod(2), fchown(2)

Definition at line 177 of file fuse.h.

## ◆ intr

int fuse_config::intr

Allow requests to be interrupted

Definition at line 140 of file fuse.h.

## ◆ intr_signal

int fuse_config::intr_signal

Specify which signal number to send to the filesystem when a request is interrupted. The default is hardcoded to USR1.

Definition at line 147 of file fuse.h.

## ◆ kernel_cache

int fuse_config::kernel_cache

This option disables flushing the cache of the file contents on every open(2). This should only be enabled on filesystems, where the file data is never changed externally (not through the mounted FUSE filesystem). Thus it is not suitable for network filesystems and other intermediate filesystems.

NOTE: if this option is not specified (and neither direct_io) data is still cached after the open(2), so a read(2) system call will not always initiate a read operation.

Internally, enabling this option causes fuse to set the `keep_cache` field of `struct fuse_file_info` - overwriting any value that was put there by the file system.

Definition at line 237 of file fuse.h.

## ◆ negative_timeout

double fuse_config::negative_timeout

The timeout in seconds for which a negative lookup will be cached. This means, that if file did not exist (lookup retuned ENOENT), the lookup will only be redone after the timeout, and the file/directory will be assumed to not exist until then. A value of zero means that negative lookups are not cached.

Definition at line 129 of file fuse.h.

## ◆ nullpath_ok

int fuse_config::nullpath_ok

If this option is given the file-system handlers for the following operations will not receive path information: read, write, flush, release, fsync, readdir, releasedir, fsyncdir, lock, ioctl and poll.

For the truncate, getattr, chmod, chown and utimens operations the path will be provided only if the struct fuse_file_info argument is NULL.

Definition at line 265 of file fuse.h.

## ◆ readdir_ino

int fuse_config::readdir_ino

If use_ino option is not given, still try to fill in the d_ino field in readdir(2). If the name was previously looked up, and is still in the cache, the inode number found there will be used. Otherwise it will be set to -1. If use_ino option is given, this option is ignored.

Definition at line 199 of file fuse.h.

## ◆ remember

int fuse_config::remember

Normally, FUSE assigns inodes to paths only for as long as the kernel is aware of them. With this option inodes are instead remembered for at least this many seconds. This will require more memory, but may be necessary when using applications that make use of inode numbers.

A number of -1 means that inodes will be remembered for the entire life-time of the file-system process.

Definition at line 159 of file fuse.h.

## ◆ set_gid

int fuse_config::set_gid

If `set_gid` is non-zero, the st_gid attribute of each file is overwritten with the value of `gid`.

Definition at line 98 of file fuse.h.

## ◆ set_mode

int fuse_config::set_mode

If `set_mode` is non-zero, the any permissions bits set in `umask` are unset in the st_mode attribute of each file.

Definition at line 112 of file fuse.h.

## ◆ set_uid

int fuse_config::set_uid

If `set_uid` is non-zero, the st_uid attribute of each file is overwritten with the value of `uid`.

Definition at line 105 of file fuse.h.

## ◆ show_help

int fuse_config::show_help

The remaining options are used by libfuse internally and should not be touched.

Definition at line 271 of file fuse.h.

## ◆ use_ino

int fuse_config::use_ino

Honor the st_ino field in the functions getattr() and fill_dir(). This value is used to fill in the st_ino field in the stat(2), lstat(2), fstat(2) functions and the d_ino field in the readdir(2) function. The filesystem does not have to guarantee uniqueness, however some applications rely on this value being unique for the whole filesystem.

Note that this does not affect the inode that libfuse and the kernel use internally (also called the "nodeid").

Definition at line 190 of file fuse.h.

The documentation for this struct was generated from the following file:

- fuse-3.2.3/include/fuse.h